function toggleMainMenu() {
	try {
		let _mainMenu = document.querySelector('.mainmenu');
		
		if(_mainMenu != null) {
			if(_mainMenu.classList.contains('opened')) {
				_mainMenu.classList.remove('opened');
			}
			else {
				_mainMenu.classList.add('opened');
			}
		}
		
		hideProductMenu();
	}
	catch(ex) {
		console.log("toggleMainMenu error: ", ex);
	}
}

function hideMainMenu() {
	try {
		let _mainMenu = document.querySelector('.mainmenu');
		
		if(_mainMenu != null) {
			_mainMenu.classList.remove('opened');
		}
		
		let _mainMenuGroups = document.querySelectorAll('.mainmenu-groupitem');
		_mainMenuGroups.forEach(function(elem) {
			elem.classList.remove('opened');
		})
	}
	catch(ex) {
		console.log("hideMainMenu error: ", ex);
	}
}

function hideProductMenu() {
	try {
		let _mobileNavToggle = document.querySelector('[data-target="#TopSubmenuNavbarCollapse"]');
		
		if(_mobileNavToggle != null) {
			_mobileNavToggle.classList.add('collapsed');
			_mobileNavToggle.setAttribute('aria-expanded', 'false')
		}
		
		let _productMenu = document.getElementById('TopSubmenuNavbarCollapse');
		
		if(_productMenu != null) {
			_productMenu.classList.remove('in');
			_productMenu.setAttribute('aria-expanded', 'false');
			_productMenu.style.height = '1px';
		}
		
		let _productSubMenus = document.querySelectorAll('#TopSubmenuNavbarCollapse li.dropdown');
		_productSubMenus.forEach(function(elem) {
			elem.classList.remove('open');
			
			let _subMenuLink = elem.querySelector('a[data-toggle="dropdown"]');
			
			if(_subMenuLink != null) {
				_subMenuLink.setAttribute('aria-expanded', 'false');
			}
		})
	}
	catch(ex) {
		console.log("hideProductMenu error: ", ex);
	}
}

function toggleMainMenuGroup(groupKey) {
	try {
		// first, find the group with the passed groupKey
		var _targetedGroupElem = document.querySelector('.mainmenu-groupitem[data-mainmenugroupitem="' + groupKey + '"]');
		var _targetIsActive = false;
		
		if(_targetedGroupElem != null) {
			_targetIsActive = _targetedGroupElem.classList.contains('opened');
		}
		
		// first, close all open groups
		var _groupElems = document.querySelectorAll('.mainmenu-groupitem');
		
		_groupElems.forEach(function(elem) {
			elem.classList.remove('opened');
		});
		
		if(!_targetIsActive && _targetedGroupElem != null) {
			if(groupKey != 'products') {
				_targetedGroupElem.classList.add('opened');
				console.log("QWEQWEQWE");
				determineMainMenuGroupPosition(groupKey).then((dimsResult) => {
					if(dimsResult != null) {
						_targetedGroupElem.style.setProperty('--mainsubmenu-x', dimsResult.Left + 'px');
					}
					
					
				});
			}
			else {
				_targetedGroupElem.classList.add('opened');
			}
		}
	}
	catch(ex) {
		console.log("toggleMainMenuGroup error: ", ex);
	}
}

function determineMainMenuGroupPosition(groupKey) {
	return new Promise((resolve, reject) => {
		try {
			let _menuGroupToggle = document.querySelector('.mainmenu-groupitem[data-mainmenugroupitem="' + groupKey + '"]');
			let _submenuElem = document.querySelector('.mainmenu-itemgroup[data-mainmenuitemgroup="' + groupKey + '"]');
			let _bodyElem = document.querySelector('body');
			
			if(_menuGroupToggle != null && _submenuElem != null && _bodyElem != null) {
				let _bodyElemDims = _bodyElem.getBoundingClientRect();
				let _toggleDims = _menuGroupToggle.getBoundingClientRect();
				let _submenuElemDims = _submenuElem.getBoundingClientRect();
				
				let _bodyWidth = _bodyElemDims.width;
				let _toggleWidth = _toggleDims.width;
				let _toggleMiddle = _toggleDims.left + (_toggleWidth / 2);
				let _submenuWidth = _submenuElemDims.width;
				
				let _submenuLeft = _toggleMiddle - (_submenuWidth / 2);
				
				if(_submenuLeft + _submenuWidth > (_bodyWidth - 40)) {
					_submenuLeft = _bodyWidth - 40 - _submenuWidth;
				}
				
				let _desiredPosition = { Left: _submenuLeft };
				
				resolve(_desiredPosition);
			}
			else {
				resolve(null);
			}
		}
		catch(ex) {
			console.log("determineMainMenuGroupPosition error: ", ex);
			
			resolve(null);
		}
	});
}

function outsideMainMenuHandler(e) {
	try {
		var _isInside = false;
		var _mainMenuElem = document.querySelector('.mainmenu');
		
		if(_mainMenuElem != null) {
			_isInside = _mainMenuElem.contains(e.target);
		}
		
		if(!_isInside) {
			hideMainMenu();
		}
	}
	catch(ex) {
		console.log("outsideMainMenuHandler error: ", ex);
	}
}

document.addEventListener('click', outsideMainMenuHandler, false);
